% ---
% This script trains similarity measures and shows the
% results regarding RBM of table 3
%
% Feature Preprocessing with RBMs for Music Similarity Learning
% Son N. Tran, Daniel Wolff, Tillman Weyde, Artur Garcez, AES53rd
% conference 
% 
% please note that the RBM training is a probabilistic process, and 
% thus the papers' results can only be reproduced approximately with 
% large numbers of iterations of this script, and selection of RBMs according to
% their training set performance.
% Here, training is done on 20 random initialisations of RBM features ,
% the test results corresponding to the RBM with the best training result are then
% returned.
%
% The train and test performances are output in the console
%
% For convenicence, The precomputed RBM features are stored in the files
% accompaining this script.
% In order to compute new SVM features, delete these files.
% ---

% ---
% get svm results for RBM
% ---
svm_table3
% svm_test_performance
%fprintf('SVM Original Test Result (Wolff etal. 2012)=71.20 / 83.54\n');

% ---
% get gradient results for RBM
% ---
gradient_table3